
/* The following line is just a forward declaration to make the code clean. */
/* One could also include <stdio.h> instead. */
void printf(const char *, ...);

int main(int argc, char *argv[])
{
	printf("hello real world!\n");
	return 0;
}


#include "internal.mh"

/* Hello World! metaprogram.
 * $main is the main equivalend of MetaC.
 * execute this example either with:
 * $ metacc hello.mc
 * or e.g.
 * $ metacc -arg a1 -arg a2 -arg a3 hello.mc
 *
 * $main will be removed from the code after metaprogram execution.
 * main will remain. So you can compile the result, and if you
 * execute the result, you will also get a hello world from the
 * "real world".
 */
meta void $main(strg arg[])
{
	strg *a;	/* defines variable a with type "strg *" */
	zed i = 0;	/* defines variable i with type "zed" */

	$print("hello meta world!\n");

	a = arg;
	if (*a) 
		$print("my arguments:\n");
	while (*a) {
		++i;
		$print("\targument "+(strg)i+": "+*a+"\n");
		++a;
	}
}
// vim:ft=c
