#include "internal.mh"

long long gethrtime(void);
int printf(const char *, ...);
void bzero(void *,int);

int square(int s)
{
	int squ;
	squ= s * s;
	return squ;
}

int main(void)
{
	int i;
	for (i = 1000000; i > 0; --i) {
		int j = square(i);
	}
	return 0;
}


/* This example demonstrates how MetaC can be used to do execution time
 * measurements. The measurement function used here is only available
 * on Solaris. If you want to run it on another system you must provide
 * a replacement for gethrtime.
 */

meta void $main(strg arg[])
{
	func all_func[], *f;
	zed i, num_func;
	symb t,wcet,p;
	strg fname;

	/* some patterns that will be needed */
	empty:= {}
	report:= print_wcet();
	init:= bzero(wcet,sizeof(wcet));
	
	
	(void) $get_all_functions(all_func);	/* do this before defining new functions */
	wcet = $define($module(),typeof(long long []),(ident)"wcet");
	
	/* declare and implement the trunc of the report function */
	p = $define($module(), typeof(void(void)), (ident) "print_wcet");
	(void) $implement(p, codeof(empty));

	$add_prologue(main, codeof(init));
	$add_epilogue(main, codeof(report));
	f = all_func;
	while (*f) {	/* now we iterate over all functions */
		prol:= t = -gethrtime();
		epil:= if ((t += gethrtime()) && (t > wcet[i]))
			wcet[i] = t;
		print_code:= printf("%s: %lli\n",fname,wcet[num_func]);
		fname = (strg) *f;
		if (fname == "main") {	/* omit main from time measurements */
			++f;
			continue;
		}
		t = $define((scope)*f,typeof(long long),(ident)"xtime");
		$add_prologue(*f,codeof(prol));
		$add_epilogue(*f,codeof(epil));
		(void) $add_stmt((stmt)(func)p,codeof(print_code));
		++f;
		++num_func;
	}
	$info("Instrumented " + (strg) num_func + " functions.");
	$resize_array(wcet,num_func);
}

/* vim:tw=0
 * vim:filetype=c
 */
