#ifdef _WIN32
/* Hacks for MS Visual Studio Compilers which are unfortunately
 * in no way standards compliant...
 */

/* I don't know how to pass __declspec(...) without major efforts,
 * so we simply remove all occurances. Sorry for that, but it is
 * really in no way standards compliant...
 */
#define __declspec(a)

/* __inline is probably the same as inline, isn't it? */
#define __inline inline

/* The standard does not define __int64, which seems to be an VC internal
 * datatype. It is probably the same as long long.
 * Note: it can't be defined as a typedef, because it is sometimes used
 * like this: unsinged __int64 a;
 */
#define __int64 long long

/*
 * chown dummy declaration - Windows does not seem to have this.
 */
int chown(const char *p,unsigned long uid,unsigned long gid);

/* Is any hack missing? Please sent complaints to the vendor of VC. */

#endif
