#include "internal.mh"

meta void execute_switch(zed c)
{
	switch (c) {
		$fatal("this should not be executed");
	case 1:
		$print("execute_switch(): case 1\n");
		break;
		$fatal("this should not be executed");
	case 2:
		$print("execute_switch(): case 2\n");
	case 3:
		$print("execute_switch(): case 3\n");
		break;
		$fatal("this should not be executed");
	default:
		$print("execute_switch(default)\n");
	}
	$print("execute_switch(): lead_out\n");
}

meta void return_early(void)
{
	return;
	$fatal("this should not be executed");
}

meta void if_test(zed c)
{
	if (c) {
		$print("if_test: then branch taken\n");
	} else
		$print("if_test: else branch taken\n");
}

meta void operator_test(void)
{
	zed zero = 0, one;
	one = 1;

	if (one == zero)
		$fatal("error in ==");
	if (one < zero)
		$fatal("error in <");
	if (zero > one)
		$fatal("error in >");
	if (1 != one)
		$fatal("error in !=");
}

meta void $main(strg arg[])
{
	zed c;
	$print("executing metaprogram\n");
	return_early();
	if (0)
		$fatal("this should not be executed");
	for (c = 4; c >= 0; c--) {
		if (c == 4)
			continue;
		$print("c = " + (strg)c + "\n");
		execute_switch(c);
		if_test(c);
	}
	
}
