
#include "internal.mh"
#ifndef _WIN32
#include "gzip-1.2.4a/deflate.c"
#endif

meta zed $insertions = 0;

meta void $trace_control_flow(func my_func)
{
	strg msg = "entering branch of " + ((strg) my_func) + " in %s at %i\n";
	stmt branches[], *b, *e;
	symb f,l;
	f = $get_symbol($module(),(ident)"__FILE__");
	l = $get_symbol($module(),(ident)"__LINE__");
	new_stm := printf(msg,f,l);

	e = $get_all_branches(my_func,branches);
	b = branches;
	while (b != e) {
		$begin(codeof new_stm,*b);
		++$insertions;
		++b;
	}
}

meta void $main(strg arg[])
{
	func funcs[], *f, *l;
	l = $get_all_functions(funcs);
	f = funcs;
	while (f != l) {
		$trace_control_flow(*f);
		++f;
	}
	$print("inserted " + (strg) $insertions + " statements\n");
}
