#include "internal.mh"

meta zed sqrtbase(zed N,zed LO,zed HI)
{
	zed mid = (LO + HI + 1) / 2;
	if (LO == HI)
		return LO;
	if (N < mid * mid)
		return sqrtbase(N,LO,mid-1);
	else
		return sqrtbase(N,mid,HI);
}

meta zed Sqrt(zed N)
{
	return sqrtbase(N,1,N);
}

meta void $main(strg arg[])
{
	strg *a = arg;
	while (*a) {
		ident id = (ident)("sqrt" + (*a));
		zed x = Sqrt((zed)*a);
		$print("sqrt("+*a+") = "+(strg)x+"\n");
		$define($module(),typeof(int),id,x);
		++a;
	}
}
